Package ghidra.pcode.struct

# Class CallExpr

java.lang.Object
ghidra.pcode.struct.Expr
ghidra.pcode.struct.CallExpr

All Implemented Interfaces:
  `StructuredSleigh.RVal`

public class CallExpr extends Expr
A p-code userop invocation expression

Userops are essentially treated as functions. They can be invoked passing a list of parameters, and the expression takes the value it returns (via `StructuredSleigh._result(RVal)`.

- ## Field Summary

  ### Fields inherited from class ghidra.pcode.struct.Expr

  `ctx, type`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `CallExpr(StructuredSleigh ctx, StructuredSleigh.UseropDecl userop, List<StructuredSleigh.RVal> args)`
  Build a call expression

- ## Method Summary

  Modifier and Type
  Method
  Description
  `default StructuredSleigh.RVal`
  `addf(StructuredSleigh.RVal rhs)`
  Generate float addition
  `default StructuredSleigh.RVal`
  `addi(long rhs)`
  Generate integer addition
  `default StructuredSleigh.RVal`
  `addi(StructuredSleigh.RVal rhs)`
  Generate integer addition
  `default StructuredSleigh.RVal`
  `andb(long rhs)`
  Generate boolean and
  `default StructuredSleigh.RVal`
  `andb(StructuredSleigh.RVal rhs)`
  Generate boolean and
  `default StructuredSleigh.RVal`
  `andi(long rhs)`
  Generate an integer (bitwise) and
  `default StructuredSleigh.RVal`
  `andi(StructuredSleigh.RVal rhs)`
  Generate an integer (bitwise) and
  `StructuredSleigh.RVal`
  `cast(DataType type)`
  Cast the value to the given type
  `default StructuredSleigh.LVal`
  `deref()`
  Generate a dereference (in the C sense) in the default address space
  `default StructuredSleigh.LVal`
  `deref(AddressSpace space)`
  Generate a dereference (in the C sense)
  `default StructuredSleigh.RVal`
  `divf(StructuredSleigh.RVal rhs)`
  Generate float division
  `default StructuredSleigh.RVal`
  `divis(long rhs)`
  Generate signed integer division
  `default StructuredSleigh.RVal`
  `divis(StructuredSleigh.RVal rhs)`
  Generate signed integer division
  `default StructuredSleigh.RVal`
  `diviu(long rhs)`
  Generate unsigned integer division
  `default StructuredSleigh.RVal`
  `diviu(StructuredSleigh.RVal rhs)`
  Generate unsigned integer division
  `default StructuredSleigh.RVal`
  `eq(long rhs)`
  Generate integer comparison: equal to
  `default StructuredSleigh.RVal`
  `eq(StructuredSleigh.RVal rhs)`
  Generate integer comparison: equal to
  `default StructuredSleigh.RVal`
  `eqf(StructuredSleigh.RVal rhs)`
  Generate float comparison: equal to
  `StringTree`
  `generate(ghidra.pcode.struct.RValInternal parent)`
  `default StructuredSleigh.RVal`
  `gtef(StructuredSleigh.RVal rhs)`
  Generate float comparison: greater than or equal to
  `default StructuredSleigh.RVal`
  `gteis(long rhs)`
  Generate signed integer comparison: greater than or equal to
  `default StructuredSleigh.RVal`
  `gteis(StructuredSleigh.RVal rhs)`
  Generate signed integer comparison: greater than or equal to
  `default StructuredSleigh.RVal`
  `gteiu(long rhs)`
  Generate unsigned integer comparison: greater than or equal to
  `default StructuredSleigh.RVal`
  `gteiu(StructuredSleigh.RVal rhs)`
  Generate unsigned integer comparison: greater than or equal to
  `default StructuredSleigh.RVal`
  `gtf(StructuredSleigh.RVal rhs)`
  Generate float comparison: greater than
  `default StructuredSleigh.RVal`
  `gtis(long rhs)`
  Generate signed integer comparison: greater than
  `default StructuredSleigh.RVal`
  `gtis(StructuredSleigh.RVal rhs)`
  Generate signed integer comparison: greater than
  `default StructuredSleigh.RVal`
  `gtiu(long rhs)`
  Generate unsigned integer comparison: greater than
  `default StructuredSleigh.RVal`
  `gtiu(StructuredSleigh.RVal rhs)`
  Generate unsigned integer comparison: greater than
  `default StructuredSleigh.RVal`
  `ltef(StructuredSleigh.RVal rhs)`
  Generate float comparison: less than or equal to
  `default StructuredSleigh.RVal`
  `lteis(long rhs)`
  Generate signed integer comparison: less than or equal to
  `default StructuredSleigh.RVal`
  `lteis(StructuredSleigh.RVal rhs)`
  Generate signed integer comparison: less than or equal to
  `default StructuredSleigh.RVal`
  `lteiu(long rhs)`
  Generate unsigned integer comparison: less than or equal to
  `default StructuredSleigh.RVal`
  `lteiu(StructuredSleigh.RVal rhs)`
  Generate unsigned integer comparison: less than or equal to
  `default StructuredSleigh.RVal`
  `ltf(StructuredSleigh.RVal rhs)`
  Generate unsigned integer comparison: less than
  `default StructuredSleigh.RVal`
  `ltis(long rhs)`
  Generate signed integer comparison: less than
  `default StructuredSleigh.RVal`
  `ltis(StructuredSleigh.RVal rhs)`
  Generate signed integer comparison: less than
  `default StructuredSleigh.RVal`
  `ltiu(long rhs)`
  Generate unsigned integer comparison: less than
  `default StructuredSleigh.RVal`
  `ltiu(StructuredSleigh.RVal rhs)`
  Generate unsigned integer comparison: less than
  `default StructuredSleigh.RVal`
  `mulf(StructuredSleigh.RVal rhs)`
  Generate float multiplication
  `default StructuredSleigh.RVal`
  `muli(long rhs)`
  Generate integer multiplication
  `default StructuredSleigh.RVal`
  `muli(StructuredSleigh.RVal rhs)`
  Generate integer multiplication
  `default StructuredSleigh.RVal`
  `neq(long rhs)`
  Generate integer comparison: not equal to
  `default StructuredSleigh.RVal`
  `neq(StructuredSleigh.RVal rhs)`
  Generate integer comparison: not equal to
  `default StructuredSleigh.RVal`
  `neqf(StructuredSleigh.RVal rhs)`
  Generate float comparison: not equal to
  `default StructuredSleigh.RVal`
  `notb()`
  Generate boolean inversion
  `default StructuredSleigh.RVal`
  `noti()`
  Generate integer (bitwise) inversion
  `default StructuredSleigh.RVal`
  `orb(long rhs)`
  Generate boolean or
  `default StructuredSleigh.RVal`
  `orb(StructuredSleigh.RVal rhs)`
  Generate boolean or
  `default StructuredSleigh.RVal`
  `ori(long rhs)`
  Generate an integer (bitwise) or
  `default StructuredSleigh.RVal`
  `ori(StructuredSleigh.RVal rhs)`
  Generate an integer (bitwise) or
  `default StructuredSleigh.RVal`
  `remis(long rhs)`
  Generate signed integer division remainder
  `default StructuredSleigh.RVal`
  `remis(StructuredSleigh.RVal rhs)`
  Generate signed integer division remainder
  `default StructuredSleigh.RVal`
  `remiu(long rhs)`
  Generate unsigned integer division remainder
  `default StructuredSleigh.RVal`
  `remiu(StructuredSleigh.RVal rhs)`
  Generate unsigned integer division remainder
  `default StructuredSleigh.RVal`
  `shli(long rhs)`
  Generate bit shift to the left
  `default StructuredSleigh.RVal`
  `shli(StructuredSleigh.RVal rhs)`
  Generate bit shift to the left
  `default StructuredSleigh.RVal`
  `shris(long rhs)`
  Generate signed bit shift to the right
  `default StructuredSleigh.RVal`
  `shris(StructuredSleigh.RVal rhs)`
  Generate signed bit shift to the right
  `default StructuredSleigh.RVal`
  `shriu(long rhs)`
  Generate unsigned bit shift to the right
  `default StructuredSleigh.RVal`
  `shriu(StructuredSleigh.RVal rhs)`
  Generate unsigned bit shift to the right
  `default StructuredSleigh.RVal`
  `subf(StructuredSleigh.RVal rhs)`
  Generate float subtraction
  `default StructuredSleigh.RVal`
  `subi(long rhs)`
  Generate integer subtraction of an immediate
  `default StructuredSleigh.RVal`
  `subi(StructuredSleigh.RVal rhs)`
  Generate integer subtraction
  `String`
  `toString()`
  `default StructuredSleigh.RVal`
  `xorb(long rhs)`
  Generate boolean exclusive or
  `default StructuredSleigh.RVal`
  `xorb(StructuredSleigh.RVal rhs)`
  Generate boolean exclusive or
  `default StructuredSleigh.RVal`
  `xori(long rhs)`
  Generate an integer (bitwise) exclusive or
  `default StructuredSleigh.RVal`
  `xori(StructuredSleigh.RVal rhs)`
  Generate an integer (bitwise) exclusive or

  ### Methods inherited from class ghidra.pcode.struct.Expr

  `getContext, getType`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### CallExpr

    protected CallExpr(StructuredSleigh ctx, StructuredSleigh.UseropDecl userop, List<StructuredSleigh.RVal> args)
    Build a call expression
    Parameters:
      `ctx` - the context
      `userop` - the userop to invoke
      `args` - the arguments to pass in (by reference)

- ## Method Details

  - ### cast

    public StructuredSleigh.RVal cast(DataType type)
    Description copied from interface: `StructuredSleigh.RVal`
    Cast the value to the given type

    This functions like a C-style pointer cast. There are no implied operations or conversions. Notably, casting between integers and floats is just a re-interpretation of the underlying bits.

    Parameters:
      `type` - the type
    Returns:
      a handle to the resulting value

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Object`

  - ### generate

    public StringTree generate(ghidra.pcode.struct.RValInternal parent)

  - ### deref

    default StructuredSleigh.LVal deref()
    Description copied from interface: `StructuredSleigh.RVal`
    Generate a dereference (in the C sense) in the default address space
    Specified by:
      `deref` in interface `StructuredSleigh.RVal`
    Returns:
      a handle to the resulting value

  - ### deref

    default StructuredSleigh.LVal deref(AddressSpace space)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate a dereference (in the C sense)

    The value is treated as an address, and the result is essentially a variable in the given target address space.

    Specified by:
      `deref` in interface `StructuredSleigh.RVal`
    Parameters:
      `space` - the address space of the result
    Returns:
      a handle to the resulting value

  - ### notb

    default StructuredSleigh.RVal notb()
    Description copied from interface: `StructuredSleigh.RVal`
    Generate boolean inversion
    Specified by:
      `notb` in interface `StructuredSleigh.RVal`
    Returns:
      a handle to the resulting value

  - ### noti

    default StructuredSleigh.RVal noti()
    Description copied from interface: `StructuredSleigh.RVal`
    Generate integer (bitwise) inversion
    Specified by:
      `noti` in interface `StructuredSleigh.RVal`
    Returns:
      a handle to the resulting value

  - ### eq

    default StructuredSleigh.RVal eq(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate integer comparison: equal to
    Specified by:
      `eq` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### eq

    default StructuredSleigh.RVal eq(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate integer comparison: equal to
    Specified by:
      `eq` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### eqf

    default StructuredSleigh.RVal eqf(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate float comparison: equal to
    Specified by:
      `eqf` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### neq

    default StructuredSleigh.RVal neq(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate integer comparison: not equal to
    Specified by:
      `neq` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### neq

    default StructuredSleigh.RVal neq(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate integer comparison: not equal to
    Specified by:
      `neq` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### neqf

    default StructuredSleigh.RVal neqf(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate float comparison: not equal to
    Specified by:
      `neqf` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### ltiu

    default StructuredSleigh.RVal ltiu(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned integer comparison: less than
    Specified by:
      `ltiu` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### ltiu

    default StructuredSleigh.RVal ltiu(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned integer comparison: less than
    Specified by:
      `ltiu` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### ltis

    default StructuredSleigh.RVal ltis(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate signed integer comparison: less than
    Specified by:
      `ltis` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### ltis

    default StructuredSleigh.RVal ltis(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate signed integer comparison: less than
    Specified by:
      `ltis` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### ltf

    default StructuredSleigh.RVal ltf(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned integer comparison: less than
    Specified by:
      `ltf` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### gtiu

    default StructuredSleigh.RVal gtiu(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned integer comparison: greater than
    Specified by:
      `gtiu` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### gtiu

    default StructuredSleigh.RVal gtiu(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned integer comparison: greater than
    Specified by:
      `gtiu` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### gtis

    default StructuredSleigh.RVal gtis(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate signed integer comparison: greater than
    Specified by:
      `gtis` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### gtis

    default StructuredSleigh.RVal gtis(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate signed integer comparison: greater than
    Specified by:
      `gtis` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### gtf

    default StructuredSleigh.RVal gtf(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate float comparison: greater than
    Specified by:
      `gtf` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### lteiu

    default StructuredSleigh.RVal lteiu(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned integer comparison: less than or equal to
    Specified by:
      `lteiu` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### lteiu

    default StructuredSleigh.RVal lteiu(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned integer comparison: less than or equal to
    Specified by:
      `lteiu` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### lteis

    default StructuredSleigh.RVal lteis(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate signed integer comparison: less than or equal to
    Specified by:
      `lteis` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### lteis

    default StructuredSleigh.RVal lteis(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate signed integer comparison: less than or equal to
    Specified by:
      `lteis` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### ltef

    default StructuredSleigh.RVal ltef(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate float comparison: less than or equal to
    Specified by:
      `ltef` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### gteiu

    default StructuredSleigh.RVal gteiu(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned integer comparison: greater than or equal to
    Specified by:
      `gteiu` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### gteiu

    default StructuredSleigh.RVal gteiu(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned integer comparison: greater than or equal to
    Specified by:
      `gteiu` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### gteis

    default StructuredSleigh.RVal gteis(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate signed integer comparison: greater than or equal to
    Specified by:
      `gteis` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### gteis

    default StructuredSleigh.RVal gteis(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate signed integer comparison: greater than or equal to
    Specified by:
      `gteis` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### gtef

    default StructuredSleigh.RVal gtef(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate float comparison: greater than or equal to
    Specified by:
      `gtef` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### orb

    default StructuredSleigh.RVal orb(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate boolean or
    Specified by:
      `orb` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### orb

    default StructuredSleigh.RVal orb(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate boolean or
    Specified by:
      `orb` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### ori

    default StructuredSleigh.RVal ori(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate an integer (bitwise) or
    Specified by:
      `ori` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### ori

    default StructuredSleigh.RVal ori(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate an integer (bitwise) or
    Specified by:
      `ori` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### xorb

    default StructuredSleigh.RVal xorb(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate boolean exclusive or
    Specified by:
      `xorb` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### xorb

    default StructuredSleigh.RVal xorb(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate boolean exclusive or
    Specified by:
      `xorb` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### xori

    default StructuredSleigh.RVal xori(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate an integer (bitwise) exclusive or
    Specified by:
      `xori` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### xori

    default StructuredSleigh.RVal xori(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate an integer (bitwise) exclusive or
    Specified by:
      `xori` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### andb

    default StructuredSleigh.RVal andb(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate boolean and
    Specified by:
      `andb` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### andb

    default StructuredSleigh.RVal andb(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate boolean and
    Specified by:
      `andb` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### andi

    default StructuredSleigh.RVal andi(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate an integer (bitwise) and
    Specified by:
      `andi` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### andi

    default StructuredSleigh.RVal andi(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate an integer (bitwise) and
    Specified by:
      `andi` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand (mask)
    Returns:
      a handle to the resulting value

  - ### shli

    default StructuredSleigh.RVal shli(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate bit shift to the left
    Specified by:
      `shli` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand (shift amount)
    Returns:
      a handle to the resulting value

  - ### shli

    default StructuredSleigh.RVal shli(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate bit shift to the left
    Specified by:
      `shli` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand (shift amount)
    Returns:
      a handle to the resulting value

  - ### shriu

    default StructuredSleigh.RVal shriu(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned bit shift to the right
    Specified by:
      `shriu` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand (shift amount)
    Returns:
      a handle to the resulting value

  - ### shriu

    default StructuredSleigh.RVal shriu(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned bit shift to the right
    Specified by:
      `shriu` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand (shift amount)
    Returns:
      a handle to the resulting value

  - ### shris

    default StructuredSleigh.RVal shris(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate signed bit shift to the right
    Specified by:
      `shris` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand (shift amount)
    Returns:
      a handle to the resulting value

  - ### shris

    default StructuredSleigh.RVal shris(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate signed bit shift to the right
    Specified by:
      `shris` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand (shift amount)
    Returns:
      a handle to the resulting value

  - ### addi

    default StructuredSleigh.RVal addi(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate integer addition
    Specified by:
      `addi` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### addi

    default StructuredSleigh.RVal addi(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate integer addition
    Specified by:
      `addi` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### addf

    default StructuredSleigh.RVal addf(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate float addition
    Specified by:
      `addf` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### subi

    default StructuredSleigh.RVal subi(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate integer subtraction
    Specified by:
      `subi` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### subi

    default StructuredSleigh.RVal subi(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate integer subtraction of an immediate
    Specified by:
      `subi` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### subf

    default StructuredSleigh.RVal subf(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate float subtraction
    Specified by:
      `subf` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### muli

    default StructuredSleigh.RVal muli(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate integer multiplication
    Specified by:
      `muli` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### muli

    default StructuredSleigh.RVal muli(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate integer multiplication
    Specified by:
      `muli` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate operand
    Returns:
      a handle to the resulting value

  - ### mulf

    default StructuredSleigh.RVal mulf(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate float multiplication
    Specified by:
      `mulf` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the second operand
    Returns:
      a handle to the resulting value

  - ### diviu

    default StructuredSleigh.RVal diviu(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned integer division
    Specified by:
      `diviu` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the divisor
    Returns:
      a handle to the resulting value

  - ### diviu

    default StructuredSleigh.RVal diviu(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned integer division
    Specified by:
      `diviu` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate divisor
    Returns:
      a handle to the resulting value

  - ### divis

    default StructuredSleigh.RVal divis(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate signed integer division
    Specified by:
      `divis` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the divisor
    Returns:
      a handle to the resulting value

  - ### divis

    default StructuredSleigh.RVal divis(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate signed integer division
    Specified by:
      `divis` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate divisor
    Returns:
      a handle to the resulting value

  - ### divf

    default StructuredSleigh.RVal divf(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate float division
    Specified by:
      `divf` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the divisor
    Returns:
      a handle to the resulting value

  - ### remiu

    default StructuredSleigh.RVal remiu(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned integer division remainder
    Specified by:
      `remiu` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the divisor
    Returns:
      a handle to the resulting value

  - ### remiu

    default StructuredSleigh.RVal remiu(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate unsigned integer division remainder
    Specified by:
      `remiu` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate divisor
    Returns:
      a handle to the resulting value

  - ### remis

    default StructuredSleigh.RVal remis(StructuredSleigh.RVal rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate signed integer division remainder
    Specified by:
      `remis` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the divisor
    Returns:
      a handle to the resulting value

  - ### remis

    default StructuredSleigh.RVal remis(long rhs)
    Description copied from interface: `StructuredSleigh.RVal`
    Generate signed integer division remainder
    Specified by:
      `remis` in interface `StructuredSleigh.RVal`
    Parameters:
      `rhs` - the immediate divisor
    Returns:
      a handle to the resulting value